Subject: Re: [RFC] New functions to manipulate registers for ethtool

From: Hitoshi Mitake <[email-masked]>
Date: Wed, 10 Dec 2008 20:26:18 +0900

On Mon, 8 Dec 2008 09:36:53 -0800
"Brandeburg, Jesse" <[email-masked]> wrote:

> David Miller wrote:
> > From: [email-masked]
> > Date: Mon, 08 Dec 2008 04:01:43 -0500
> > 
> >> On Mon, 08 Dec 2008 00:54:31 PST, David Miller said:
> >>> From: Hitoshi Mitake <[email-masked]>
> >>> Date: Mon, 8 Dec 2008 17:12:30 +0900
> >>> 
> >>>> I want to add two new functions to ethtool.
> >>>> 
> >>>> One is for setting driver's registers on MMIO area like
> >>>> --change-eeprom option.
> >>> 
> >>> You can map the registers into userspace using the bus
> >>> level mmap facilities exported to userspace.
> 
> one hiccup, Arjan recently added functionality to the kernel that could
> disallow this unless a user overrides at boot. [1]
> 
> also, there is a .config option that disallows this but I'm just
> mentioning it for posterity.
> 
> >>> No ethtool support is necessary for this.
> >> 
> >> Yes, but if Hitoshi wants to tell a user "run this command and send
> >> me the output", what's the incantation the user needs to use?
> > 
> 
> ethregs -s <bus>:<dev>.<fn>
> 
> > That's an awful reason to have to two ways of doing the exact same
> > thing from userspace.
> > 
> > Write the tool.  Someone will if it's important enough (in fact
> > such code probably exists already).

Thanks for your replying, David, Valdis and Jesse.

> 
> Hi Hitoshi,
> you probably want to download and install our ethregs utility.
> http://prdownloads.sf.net/e1000/ethregs-1.1.tar.gz
> (this is not a direct link as it seems but gets redirected to a mirror
> page, usually)
> 

This is a nice software for me, Thanks.

> Please let me know if it doesn't support your device ID.

I used this on my environment.
My NICs are 82573L and 82573E. ethregs could detected them well.

It seems that this program doesn't support for writing value to registers.
I think making ethregs to support writing is not bad idea.
If you are not planning, I want to do that.

I'm not a professional of Intel's NICs.
How do you think?